// 加速度をProcessginで視覚化（Processing側）
// 2017.12 nakayasu

import processing.serial.*; // シリアルライブラリの読み込み
Serial myPort;
int[] serialInArray = new int[3];
int serialCount = 0;
int[] xvals;
int[] yvals;
int[] zvals;
int a0 = -1000;
int a1 = -1000;
int a2 = -1000;
boolean firstContact = false;
 
void setup()
{
  size(600, 400);
  xvals = new int[width];
  yvals = new int[width];
  zvals = new int[width];
  for(int i=1; i < width; i++) {
    xvals[i] = -300;
    yvals[i] = -200;
    zvals[i] = -200;
  }
  printArray(Serial.list()); // コンソールにシリアルデバイスの表示
  String portName = Serial.list()[3]; //シリアルデバイスナンバー
  myPort = new Serial(this, portName, 9600);
}
 
void draw()
{
  background(0);
  stroke(60);
  line(0, height/6, width, height/6);
  line(0, 3*height/6, width, 3*height/6);
  line(0, 5*height/6, width, 5*height/6);
 
  for(int i=1; i < width; i++) {
    xvals[i-1] = xvals[i];
    yvals[i-1] = yvals[i];
    zvals[i-1] = zvals[i];
  }
  // Add the new values to the end of the array
  xvals[width-1] = a2; //X A3 to 6pin on KXM52-1050
  yvals[width-1] = a1; //Y A2 to 7pin on KXM52-1050
  zvals[width-1] = a0; //Z A1 to 8pin on KXM52-1050
 
  for(int i=1; i < width; i++) {
    stroke(0, 180,255); point(i, xvals[i]-58);
    stroke(255, 20,0); point(i, yvals[i]+73);
    stroke(0, 255,0); point(i, zvals[i]+142);
  }
 
  fill(0, 180,255); text("X: " + a2, 10, 15);
  fill(255, 20, 0); text("Y: " + a1, 10, 15 + height/3);
  fill(0, 255, 0); text("Z: " + a0, 10, 15+2* height/3);
}
 
void serialEvent(Serial myPort) {
  int inByte = myPort.read();
  if (firstContact == false) {
    if (inByte == 'A') {
      myPort.clear(); // clear the serial port buffer
      firstContact = true; // you've had first contact from the microcontroller
      myPort.write('A'); // ask for more
    }
  } else {
    // Add the latest byte from the serial port to array:
    serialInArray[serialCount] = inByte;
    serialCount++;
    if (serialCount > 2 ) {
      a0 = serialInArray[0];
      a1 = serialInArray[1];
      a2 = serialInArray[2];
      myPort.write('A'); // Send a capital A to request new sensor readings:
      serialCount = 0; // Reset serialCount:
    }
  }
}